# debuginfo not supported with Go
%global debug_package %{nil}

%global golang_version 1.8

%global org jaegertracing

%global orgdir src/github.com/%{org}

%global builddir %{orgdir}/%{name}

Name:           jaeger
Version:        v1.6.0.redhat1
Release:        6%{?dist}
Summary:        Jaeger distributed tracing system.

License:        Apache-2.0
URL:            https://github.com/jaegertracing/jaeger
#The source should be with a git commit:
Source0:        %{name}-%{version}.tar.gz
Source1:        %{name}-ui-%{version}.tar.gz

BuildArch: x86_64
BuildRequires: golang >= %{golang_version}
BuildRequires: rh-nodejs6


%description
The Jaeger OpenTracing compliant distributed tracing system.

%prep
rm -rf %{name}-%{version}
pushd ${PWD}
%setup
%setup -T -D -a 1
popd
rm -rf %{name}-%{version}/%{name}-ui
mv %{name}-%{version}/%{name}-ui-%{version} %{name}-%{version}/%{name}-ui
mkdir -p tmpdir/%{orgdir}
mv %{name}-%{version} tmpdir/%{builddir}
mv tmpdir %{name}-%{version}

%build
export GOPATH=${PWD}:%{gopath}
export GOBIN=${PWD}/bin
pushd %{builddir}
export CGO_ENABLED=0
export GOOS=linux
export installsuffix=cgo

# Build the 'statik' tool, source already located in the vendor folder
pushd vendor/github.com/rakyll/statik
go get .
echo Built statik tool
ls -l ${GOBIN}
popd

# Build the static assets for the UI
pushd jaeger-ui
scl enable rh-nodejs6 'npm run build'
popd

# Use 'statik' to bundle the static assets in Go code which will be compiled into the jaeger-query executable
pushd cmd/query/app/ui/actual
${GOBIN}/statik -f -src ../../../../../jaeger-ui/build
popd

go build -ldflags="-s -w" -o ./cmd/agent/agent-linux ./cmd/agent/main.go
go build -ldflags="-s -w" -o ./cmd/collector/collector-linux ./cmd/collector/main.go
go build -ldflags="-s -w" -tags ui -o ./cmd/query/query-linux ./cmd/query/main.go

popd

%install
mkdir -p %{buildroot}/usr/bin
cp %{builddir}/cmd/agent/agent-linux %{buildroot}/usr/bin
cp %{builddir}/cmd/collector/collector-linux %{buildroot}/usr/bin
cp %{builddir}/cmd/query/query-linux %{buildroot}/usr/bin

%clean
rm -rf %{buildroot}

%files
/usr/bin/agent-linux
/usr/bin/collector-linux
/usr/bin/query-linux

